unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient;

type
  TForm1 = class(TForm)
    EIPAdress: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    EValues: TEdit;
    IdTCPClient1: TIdTCPClient;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    ClipX1 : TIdTCPClient;
    function Receive(const msg: string): string;
    procedure Send(const msg: string);

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//----------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
begin
   caption := 'ClipX - Example (Delphi XE7)';
              // Windows 7 / 32bit

   EIPAdress.Text := '192.168.0.27';
end;

//----------------------------------------------------------------------------

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if assigned(ClipX1) then
     ClipX1.free;
end;

//----------------------------------------------------------------------------

procedure TForm1.Button1Click(Sender: TObject);
begin
  if assigned(ClipX1) then
     exit;
  try
     ClipX1      := IdTCPClient1.Create(self);
     ClipX1.Host := Trim(EIPAdress.Text);
     ClipX1.Port := 55000;

     ClipX1.Connect;
  except
    raise Exception.Create('>connection failed<');
  end;
end;

//----------------------------------------------------------------------------

procedure TForm1.Send(const msg : string);
begin
    if assigned(ClipX1) then
       ClipX1.Socket.WriteLn(msg);
end;

//----------------------------------------------------------------------------

function TForm1.Receive(const msg : string) : string;
begin
    if not assigned(ClipX1) then
       exit;

    ClipX1.Socket.WriteLn(msg);
    result := Trim(ClipX1.Socket.ReadLn(#10 {= LF}, 100 {=timeout in [ms]} ));
end;

//----------------------------------------------------------------------------

procedure TForm1.Button2Click(Sender: TObject);
begin
  // brutto-measurement :
  EValues.Text := Receive('SDO? 0x44f0,4LF'); // including LF = #10
end;

//----------------------------------------------------------------------------

procedure TForm1.Button3Click(Sender: TObject);
var s : string;
begin
   // Zero-adjustment :
   s := Receive('SDO 0x4410,4,0LF'); // including LF = #10

   if s <> '0' then
      ShowMessage('Error : Send-commend -> result <> 0');

end;



end.
